<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (128)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="arraybuffer-binary-arrays">ArrayBuffer, binary arrays</h1>
    <p>
      In web-development we meet binary data mostly while dealing with files
      (create, upload, download). Another typical use case is image processing.
    </p>
    <p>
      That’s all possible in JavaScript, and binary operations are
      high-performant.
    </p>
    <p>
      Although, there’s a bit of confusion, because there are many classes. To
      name a few:
    </p>
    <ul>
      <li>
        <code>ArrayBuffer</code>, <code>Uint8Array</code>,
        <code>DataView</code>, <code>Blob</code>, <code>File</code>, etc.
      </li>
    </ul>
    <p>
      Binary data in JavaScript is implemented in a non-standard way, compared
      to other languages. But when we sort things out, everything becomes fairly
      simple.
    </p>
    <p>
      <strong
        >The basic binary object is <code>ArrayBuffer</code> – a reference to a
        fixed-length contiguous memory area.</strong
      >
    </p>
    <p>We create it like this:</p>
    <p>
      <code
        >js run let buffer = new ArrayBuffer(16); // create a buffer of length
        16 alert(buffer.byteLength); // 16</code
      >
    </p>
    <p>
      This allocates a contiguous memory area of 16 bytes and pre-fills it with
      zeroes.
    </p>
    <p>
      ``<code>warn header="</code>ArrayBuffer<code
        >is not an array of something" Let's eliminate a possible source of
        confusion.</code
      >ArrayBuffer<code>has nothing in common with</code>Array`:
    </p>
    <ul>
      <li>It has a fixed length, we can’t increase or decrease it.</li>
      <li>It takes exactly that much space in the memory.</li>
      <li>
        To access individual bytes, another “view” object is needed, not
        <code>buffer[index]</code>.
      </li>
    </ul>
    <pre><code>
`ArrayBuffer` is a memory area. What&#39;s stored in it? It has no clue. Just a raw sequence of bytes.

**To manipulate an `ArrayBuffer`, we need to use a &quot;view&quot; object.**

A view object does not store anything on it&#39;s own. It&#39;s the &quot;eyeglasses&quot; that give an interpretation of the bytes stored in the `ArrayBuffer`.

For instance:

- **`Uint8Array`** -- treats each byte in `ArrayBuffer` as a separate number, with possible values from 0 to 255 (a byte is 8-bit, so it can hold only that much). Such value is called a &quot;8-bit unsigned integer&quot;.
- **`Uint16Array`** -- treats every 2 bytes as an integer, with possible values from 0 to 65535. That&#39;s called a &quot;16-bit unsigned integer&quot;.
- **`Uint32Array`** -- treats every 4 bytes as an integer, with possible values from 0 to 4294967295. That&#39;s called a &quot;32-bit unsigned integer&quot;.
- **`Float64Array`** -- treats every 8 bytes as a floating point number with possible values from &lt;code&gt;5.0x10&lt;sup&gt;-324&lt;/sup&gt;&lt;/code&gt; to &lt;code&gt;1.8x10&lt;sup&gt;308&lt;/sup&gt;&lt;/code&gt;.

So, the binary data in an `ArrayBuffer` of 16 bytes can be interpreted as 16 &quot;tiny numbers&quot;, or 8 bigger numbers (2 bytes each), or 4 even bigger (4 bytes each), or 2 floating-point values with high precision (8 bytes each).

![](arraybuffer-views.svg)

`ArrayBuffer` is the core object, the root of everything, the raw binary data.

But if we&#39;re going to write into it, or iterate over it, basically for almost any operation – we must use a view, e.g:

```js run
let buffer = new ArrayBuffer(16); // create a buffer of length 16

*!*
let view = new Uint32Array(buffer); // treat buffer as a sequence of 32-bit integers

alert(Uint32Array.BYTES_PER_ELEMENT); // 4 bytes per integer
*/!*

alert(view.length); // 4, it stores that many integers
alert(view.byteLength); // 16, the size in bytes

// let&#39;s write a value
view[0] = 123456;

// iterate over values
for(let num of view) {
  alert(num); // 123456, then 0, 0, 0 (4 values total)
}
</code></pre>
    <h2 id="typedarray">TypedArray</h2>
    <p>
      The common term for all these views (<code>Uint8Array</code>,
      <code>Uint32Array</code>, etc) is
      <a href="https://tc39.github.io/ecma262/#sec-typedarray-objects"
        >TypedArray</a
      >. They share the same set of methods and properities.
    </p>
    <p>
      Please note, there’s no constructor called <code>TypedArray</code>, it’s
      just a common “umbrella” term to represent one of views over
      <code>ArrayBuffer</code>: <code>Int8Array</code>,
      <code>Uint8Array</code> and so on, the full list will soon follow.
    </p>
    <p>
      When you see something like <code>new TypedArray</code>, it means any of
      <code>new Int8Array</code>, <code>new Uint8Array</code>, etc.
    </p>
    <p>
      Typed arrays behave like regular arrays: have indexes and are iterable.
    </p>
    <p>
      A typed array constructor (be it <code>Int8Array</code> or
      <code>Float64Array</code>, doesn’t matter) behaves differently depending
      on argument types.
    </p>
    <p>There are 5 variants of arguments:</p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">new</span> <span class="at">TypedArray</span>(buffer<span class="op">,</span> [byteOffset]<span class="op">,</span> [length])<span class="op">;</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="kw">new</span> <span class="at">TypedArray</span>(object)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="kw">new</span> <span class="at">TypedArray</span>(typedArray)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="kw">new</span> <span class="at">TypedArray</span>(length)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="kw">new</span> <span class="at">TypedArray</span>()<span class="op">;</span></a></code></pre>
    </div>
    <ol type="1">
      <li>
        <p>
          If an <code>ArrayBuffer</code> argument is supplied, the view is
          created over it. We used that syntax already.
        </p>
        <p>
          Optionally we can provide <code>byteOffset</code> to start from (0 by
          default) and the <code>length</code> (till the end of the buffer by
          default), then the view will cover only a part of the
          <code>buffer</code>.
        </p>
      </li>
      <li>
        <p>
          If an <code>Array</code>, or any array-like object is given, it
          creates a typed array of the same length and copies the content.
        </p>
        <p>We can use it to pre-fill the array with the data:</p>
        <p>
          <code
            >js run *!* let arr = new Uint8Array([0, 1, 2, 3]); */!* alert(
            arr.length ); // 4, created binary array of the same length alert(
            arr[1] ); // 1, filled with 4 bytes (unsigned 8-bit integers) with
            given values</code
          >
        </p>
      </li>
      <li>
        <p>
          If another <code>TypedArray</code> is supplied, it does the same:
          creates a typed array of the same length and copies values. Values are
          converted to the new type in the process, if needed.
        </p>
        <p>
          <code
            >js run let arr16 = new Uint16Array([1, 1000]); *!* let arr8 = new
            Uint8Array(arr16); */!* alert( arr8[0] ); // 1 alert( arr8[1] ); //
            232, tried to copy 1000, but can't fit 1000 into 8 bits
            (explanations below)</code
          >
        </p>
      </li>
      <li>
        <p>
          For a numeric argument <code>length</code> – creates the typed array
          to contain that many elements. Its byte length will be
          <code>length</code> multiplied by the number of bytes in a single item
          <code>TypedArray.BYTES_PER_ELEMENT</code>:
        </p>
        <p>
          <code
            >js run let arr = new Uint16Array(4); // create typed array for 4
            integers alert(Uint16Array.BYTES_PER_ELEMENT); // 2 bytes per
            integer alert(arr.byteLength); // 8 (size in bytes)</code
          >
        </p>
      </li>
      <li><p>Without arguments, creates an zero-length typed array.</p></li>
    </ol>
    <p>
      We can create a <code>TypedArray</code> directly, without mentioning
      <code>ArrayBuffer</code>. But a view cannot exist without an underlying
      <code>ArrayBuffer</code>, so gets created automatically in all these cases
      except the first one (when provided).
    </p>
    <p>To access the <code>ArrayBuffer</code>, there are properties:</p>
    <ul>
      <li>
        <code>arr.buffer</code> – references the <code>ArrayBuffer</code>.
      </li>
      <li>
        <code>arr.byteLength</code> – the length of the
        <code>ArrayBuffer</code>.
      </li>
    </ul>
    <p>So, we can always move from one view to another:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">let</span> arr8 <span class="op">=</span> <span class="kw">new</span> <span class="at">Uint8Array</span>([<span class="dv">0</span><span class="op">,</span> <span class="dv">1</span><span class="op">,</span> <span class="dv">2</span><span class="op">,</span> <span class="dv">3</span>])<span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2"></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="co">// another view on the same data</span></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="kw">let</span> arr16 <span class="op">=</span> <span class="kw">new</span> <span class="at">Uint16Array</span>(<span class="va">arr8</span>.<span class="at">buffer</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>Here’s the list of typed arrays:</p>
    <ul>
      <li>
        <code>Uint8Array</code>, <code>Uint16Array</code>,
        <code>Uint32Array</code> – for integer numbers of 8, 16 and 32 bits.
        <ul>
          <li>
            <code>Uint8ClampedArray</code> – for 8-bit integers, “clamps” them
            on assignment (see below).
          </li>
        </ul>
      </li>
      <li>
        <code>Int8Array</code>, <code>Int16Array</code>,
        <code>Int32Array</code> – for signed integer numbers (can be negative).
      </li>
      <li>
        <code>Float32Array</code>, <code>Float64Array</code> – for signed
        floating-point numbers of 32 and 64 bits.
      </li>
    </ul>
    <p>
      ``<code>warn header="No</code>int8<code
        >or similar single-valued types" Please note, despite of the names
        like</code
      >Int8Array<code>, there's no single-value type like</code>int<code
        >, or</code
      >int8` in JavaScript.
    </p>
    <p>
      That’s logical, as <code>Int8Array</code> is not an array of these
      individual values, but rather a view on <code>ArrayBuffer</code>.
    </p>
    <pre><code>
### Out-of-bounds behavior

What if we attempt to write an out-of-bounds value into a typed array? There will be no error. But extra bits are cut-off.

For instance, let&#39;s try to put 256 into `Uint8Array`. In binary form, 256 is `100000000` (9 bits), but `Uint8Array` only provides 8 bits per value, that makes the available range from 0 to 255.

For bigger numbers, only the rightmost (less significant) 8 bits are stored, and the rest is cut off:

![](8bit-integer-256.svg)

So we&#39;ll get zero.

For 257, the binary form is `100000001` (9 bits), the rightmost 8 get stored, so we&#39;ll have `1` in the array:

![](8bit-integer-257.svg)

In other words, the number modulo 2&lt;sup&gt;8&lt;/sup&gt; is saved.

Here&#39;s the demo:

```js run
let uint8array = new Uint8Array(16);

let num = 256;
alert(num.toString(2)); // 100000000 (binary representation)

uint8array[0] = 256;
uint8array[1] = 257;

alert(uint8array[0]); // 0
alert(uint8array[1]); // 1</code></pre>
    <p>
      <code>Uint8ClampedArray</code> is special in this aspect, its behavior is
      different. It saves 255 for any number that is greater than 255, and 0 for
      any negative number. That behavior is useful for image processing.
    </p>
    <h2 id="typedarray-methods">TypedArray methods</h2>
    <p>
      <code>TypedArray</code> has regular <code>Array</code> methods, with
      notable exceptions.
    </p>
    <p>
      We can iterate, <code>map</code>, <code>slice</code>, <code>find</code>,
      <code>reduce</code> etc.
    </p>
    <p>There are few things we can’t do though:</p>
    <ul>
      <li>
        No <code>splice</code> – we can’t “delete” a value, because typed arrays
        are views on a buffer, and these are fixed, contiguous areas of memory.
        All we can do is to assign a zero.
      </li>
      <li>No <code>concat</code> method.</li>
    </ul>
    <p>There are two additional methods:</p>
    <ul>
      <li>
        <code>arr.set(fromArr, [offset])</code> copies all elements from
        <code>fromArr</code> to the <code>arr</code>, starting at position
        <code>offset</code> (0 by default).
      </li>
      <li>
        <code>arr.subarray([begin, end])</code> creates a new view of the same
        type from <code>begin</code> to <code>end</code> (exclusive). That’s
        similar to <code>slice</code> method (that’s also supported), but
        doesn’t copy anything – just creates a new view, to operate on the given
        piece of data.
      </li>
    </ul>
    <p>
      These methods allow us to copy typed arrays, mix them, create new arrays
      from existing ones, and so on.
    </p>
    <h2 id="dataview">DataView</h2>
    <p>
      <a href="mdn:/JavaScript/Reference/Global_Objects/DataView">DataView</a>
      is a special super-flexible “untyped” view over <code>ArrayBuffer</code>.
      It allows to access the data on any offset in any format.
    </p>
    <ul>
      <li>
        For typed arrays, the constructor dictates what the format is. The whole
        array is supposed to be uniform. The i-th number is <code>arr[i]</code>.
      </li>
      <li>
        With <code>DataView</code> we access the data with methods like
        <code>.getUint8(i)</code> or <code>.getUint16(i)</code>. We choose the
        format at method call time instead of the construction time.
      </li>
    </ul>
    <p>The syntax:</p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">new</span> <span class="at">DataView</span>(buffer<span class="op">,</span> [byteOffset]<span class="op">,</span> [byteLength])<span class="op">;</span></a></code></pre>
    </div>
    <ul>
      <li>
        <strong><code>buffer</code></strong> – the underlying
        <code>ArrayBuffer</code>. Unlike typed arrays,
        <code>DataView</code> doesn’t create a buffer on its own. We need to
        have it ready.
      </li>
      <li>
        <strong><code>byteOffset</code></strong> – the starting byte position of
        the view (by default 0).
      </li>
      <li>
        <strong><code>byteLength</code></strong> – the byte length of the view
        (by default till the end of <code>buffer</code>).
      </li>
    </ul>
    <p>
      For instance, here we extract numbers in different formats from the same
      buffer:
    </p>
    <p>
      ```js run // binary array of 4 bytes, all have the maximal value 255 let
      buffer = new Uint8Array([255, 255, 255, 255]).buffer;
    </p>
    <p>let dataView = new DataView(buffer);</p>
    <p>// get 8-bit number at offset 0 alert(dataView.getUint8(0)); // 255</p>
    <p>
      // now get 16-bit number at offset 0, it consists of 2 bytes, together
      interpreted as 65535 alert(dataView.getUint16(0)); // 65535 (biggest
      16-bit unsigned int)
    </p>
    <p>
      // get 32-bit number at offset 0 alert(dataView.getUint32(0)); //
      4294967295 (biggest 32-bit unsigned int)
    </p>
    <p>
      dataView.setUint32(0, 0); // set 4-byte number to zero, thus setting all
      bytes to 0 ```
    </p>
    <p>
      <code>DataView</code> is great when we store mixed-format data in the same
      buffer. For example, when we store a sequence of pairs (16-bit integer,
      32-bit float), <code>DataView</code> allows to access them easily.
    </p>
    <h2 id="summary">Summary</h2>
    <p>
      <code>ArrayBuffer</code> is the core object, a reference to the
      fixed-length contiguous memory area.
    </p>
    <p>
      To do almost any operation on <code>ArrayBuffer</code>, we need a view.
    </p>
    <ul>
      <li>
        It can be a <code>TypedArray</code>:
        <ul>
          <li>
            <code>Uint8Array</code>, <code>Uint16Array</code>,
            <code>Uint32Array</code> – for unsigned integers of 8, 16, and 32
            bits.
          </li>
          <li>
            <code>Uint8ClampedArray</code> – for 8-bit integers, “clamps” them
            on assignment.
          </li>
          <li>
            <code>Int8Array</code>, <code>Int16Array</code>,
            <code>Int32Array</code> – for signed integer numbers (can be
            negative).
          </li>
          <li>
            <code>Float32Array</code>, <code>Float64Array</code> – for signed
            floating-point numbers of 32 and 64 bits.
          </li>
        </ul>
      </li>
      <li>
        Or a <code>DataView</code> – the view that uses methods to specify a
        format, e.g. <code>getUint8(offset)</code>.
      </li>
    </ul>
    <p>
      In most cases we create and operate directly on typed arrays, leaving
      <code>ArrayBuffer</code> under cover, as a “common denominator”. We can
      access it as <code>.buffer</code> and make another view if needed.
    </p>
    <p>
      There are also two additional terms, that are used in descriptions of
      methods that operate on binary data:
    </p>
    <ul>
      <li>
        <code>ArrayBufferView</code> is an umbrella term for all these kinds of
        views.
      </li>
      <li>
        <code>BufferSource</code> is an umbrella term for
        <code>ArrayBuffer</code> or <code>ArrayBufferView</code>.
      </li>
    </ul>
    <p>
      We’ll see these terms in the next chapters. <code>BufferSource</code> is
      one of the most common terms, as it means “any kind of binary data” – an
      <code>ArrayBuffer</code> or a view over it.
    </p>
    <p>Here’s a cheatsheet:</p>
    <p><img src="arraybuffer-view-buffersource.svg" /></p>
  </body>
</html>
